"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var WebViewUtils = (function (_super) {
    __extends(WebViewUtils, _super);
    function WebViewUtils() {
        var _this = _super.call(this) || this;
        _this.headersAddedTo = new Set();
        return global.__native(_this);
    }
    WebViewUtils.addHeaders = function (wv, headers) {
        WebViewUtils.headers = headers;
        setTimeout(function () {
            wv.android.setWebViewClient(WebViewUtils.initWithView(wv));
        });
    };
    WebViewUtils.initWithView = function (view) {
        var client = new WebViewUtils();
        client._view = view;
        client._origClient = view._webViewClient;
        return client;
    };
    WebViewUtils.prototype.shouldOverrideUrlLoading = function (view, urlOrWebResourceRequest) {
        var url = typeof urlOrWebResourceRequest === "string" ? urlOrWebResourceRequest : urlOrWebResourceRequest.getUrl().toString();
        view.loadUrl(url, this.getAdditionalHeadersForUrl(url));
        return true;
    };
    WebViewUtils.prototype.onPageStarted = function (view, url, favicon) {
        _super.prototype.onPageStarted.call(this, view, url, favicon);
        if (this._view && url.indexOf("http") === 0 && !this.headersAddedTo.has(url)) {
            this._view.android.loadUrl(url, this.getAdditionalHeadersForUrl(url));
        }
    };
    WebViewUtils.prototype.getAdditionalHeadersForUrl = function (url) {
        var headers = new java.util.HashMap();
        if (!this.headersAddedTo.has(url)) {
            WebViewUtils.headers.forEach(function (val, key) {
                headers.put(key, val);
            });
            this.headersAddedTo.add(url);
        }
        return headers;
    };
    return WebViewUtils;
}(android.webkit.WebViewClient));
exports.WebViewUtils = WebViewUtils;
