"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var WebViewUtils = (function (_super) {
    __extends(WebViewUtils, _super);
    function WebViewUtils() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WebViewUtils.addHeaders = function (wv, headers) {
        wv._delegate = WebViewUtils.initWithOwner(new WeakRef(wv));
        WebViewUtils.headers = headers;
    };
    WebViewUtils.initWithOwner = function (owner) {
        var delegate = new WebViewUtils();
        delegate._owner = owner;
        delegate._originalDelegate = owner.get()._delegate;
        return delegate;
    };
    WebViewUtils.prototype.webViewShouldStartLoadWithRequestNavigationType = function (webView, request, navigationType) {
        var urlString = request.URL.absoluteString;
        var isNavigationTypeBackForward = navigationType === 2;
        var isHttpRequest = urlString.indexOf("http") === 0;
        var areHeadersAdded = true;
        WebViewUtils.headers.forEach(function (val, key) {
            areHeadersAdded = areHeadersAdded && request.valueForHTTPHeaderField(key) === val;
        });
        if (!isHttpRequest || isNavigationTypeBackForward || areHeadersAdded || urlString === "about:blank") {
            return this._originalDelegate.webViewShouldStartLoadWithRequestNavigationType(webView, request, navigationType);
        }
        var nsMutableURLRequest = new NSMutableURLRequest({
            URL: request.URL,
            cachePolicy: 0,
            timeoutInterval: 60
        });
        WebViewUtils.headers.forEach(function (val, key) {
            nsMutableURLRequest.setValueForHTTPHeaderField(val, key);
        });
        webView.loadRequest(nsMutableURLRequest);
        return false;
    };
    WebViewUtils.prototype.webViewDidStartLoad = function (webView) {
        this._originalDelegate.webViewDidStartLoad(webView);
    };
    WebViewUtils.prototype.webViewDidFinishLoad = function (webView) {
        this._originalDelegate.webViewDidFinishLoad(webView);
    };
    WebViewUtils.prototype.webViewDidFailLoadWithError = function (webView, error) {
        this._originalDelegate.webViewDidFailLoadWithError(webView, error);
    };
    WebViewUtils.ObjCProtocols = [UIWebViewDelegate];
    return WebViewUtils;
}(NSObject));
exports.WebViewUtils = WebViewUtils;
